#pragma once

#include <openssl/rsa.h>
#include <openssl/err.h>
//#include <openssl/objects.h>
//#include <openssl/ssl.h>
//#include <openssl/x509.h>
//#include <openssl/md5.h>


class CIkRSA
{
	RSA * m_rsa;
	int m_padding;
public:
	static int sRSA_EncryptByPublicKey(const BYTE * pRSA_PublicKey, int nKeyLen, const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen, int padding = RSA_PKCS1_PADDING);
	static int sRSA_EncryptByPublicKey(RSA * rsa, const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen, int padding = RSA_PKCS1_PADDING);

	static int sRSA_DecryptByPublicKey(const BYTE * pRSA_PublicKey, int nKeyLen, const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen, int padding = RSA_PKCS1_PADDING);
	static int sRSA_DecryptByPublicKey(RSA * rsa, const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen, int padding = RSA_PKCS1_PADDING);

	static int sRSA_EncryptByPrivateKey(const BYTE * pRSA_PrivateKey, int nKeyLen, const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen, int padding = RSA_PKCS1_PADDING);
	static int sRSA_EncryptByPrivateKey(RSA * rsa, const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen, int padding = RSA_PKCS1_PADDING);
	
	static int sRSA_DecryptByPrivateKey(const BYTE * pRSA_PrivateKey, int nKeyLen, const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen, int padding = RSA_PKCS1_PADDING);
	static int sRSA_DecryptByPrivateKey(RSA * rsa, const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen, int padding = RSA_PKCS1_PADDING);
	
	static RSA * sRSA_GenerateKey();
	static void sRSA_Free( RSA * rsa );
	static int sRSA_GetPublicKey(RSA * rsa, BYTE ** ppOutBuffer, void* (*mem_allocator)(size_t) = malloc);
	static int sRSA_GetPrivateKey(RSA * rsa, BYTE ** ppOutBuffer, void* (*mem_allocator)(size_t) = malloc);

public:
	CIkRSA(void);
	~CIkRSA(void);
	
	bool Create_InternalKey(int seed, int padding = RSA_PKCS1_PADDING);
	bool Initialize_By_ExternalKey(const BYTE * pRSA_PublicKey, int nPubKeyLen, const BYTE * pRSA_PrivateKey, int nPriKeyLen, int padding = RSA_PKCS1_PADDING);

	int GetPublicKey(BYTE ** ppOutBuffer, void* (*mem_allocator)(size_t) = malloc);
	int GetPrivateKey(BYTE ** ppOutBuffer, void* (*mem_allocator)(size_t) = malloc);

	
	int Public_Encrypt(const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen);
	int Public_Decrypt(const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen);

	int Private_Encrypt(const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen);
	int Private_Decrypt(const BYTE * pSrcData, int nSrcLen, BYTE * pOutBuffer, int nOutBufferLen);
};
